import { ApplicationConfig, importProvidersFrom } from '@angular/core';
import { StoreModule } from '@ngrx/store';
import { counterReducer } from './counter.reducer';

export const appConfig: ApplicationConfig = {
  /* StoreModule otetaan käyttöön standalone-sovelluksessa app.config-tiedostossa.
     Store saa samalla käyttöönsa reducerin.

     Jos sovellus ei ole standalone, StoreModulen määrittely tehdään
     app.module.ts:ssä.
  */
  providers: [
    importProvidersFrom(StoreModule.forRoot({ count: counterReducer })),
  ],
};
