import { createReducer, on } from '@ngrx/store';
import { increment, decrement, reset } from './counter.actions';

/*
Reducerit suorittavat actionit.
Tilan muutokset käsitellään puhtailla funktioilla, 
joita kutsutaan reducer-funktioiksi. Ne saavat nykyisen tilan (state) 
ja valitun actionin ja laskevat niiden perusteella uuden tilan.

Tämä Reducer-tiedosto tarjotaan storelle app.config.ts -tiedostossa.
Näin ollen reducer-funktioiden toteuttamat tilan muutokset välittyvät 
storeen.
*/

export const initialState = 0; // alkutila menee storeen tästä

export const counterReducer = createReducer(
  initialState,
  on(increment, (state) => state + 1), // (state) => state + 1 on reducer-funktio
  on(decrement, (state) => state - 1),
  on(reset, (state) => 0)
);