/*
Counter2-komponentti käyttää samaa storea kuin counter1-komponentti.
Koko sovellukselle yhteinen Store määritellään app.config.ts:ssä
*/
import { Component } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Store, select } from '@ngrx/store';
import { Observable } from 'rxjs';
import { increment } from '../counter.actions';
import { Counterdata } from '../counterdata';

@Component({
  selector: 'app-counter2',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './counter2.component.html',
  styleUrls: ['./counter2.component.css'],
})
export class Counter2Component {
  count$: Observable<number>;

  /*
   Store otetaan käyttöön test-komponentissa aivan samalla tavalla
   kuin counter-komponentissa, eli luodaan store-olio, josta
   haetaan tietoa select-metodilla.
  */
  constructor(private store: Store<Counterdata>) {
    this.count$ = store.pipe(select('count'));
  }

  /* 
    increment-metodi suorittaa increment-actionin.
    Action välitetään reducerin kautta (dispatch) storeen, 
    jolloin storessa count lisääntyy yhdellä
  */
  increment() {
    this.store.dispatch(increment());
  }
}
